/**
 * Information Industrielle et Java
 * solution de l'exercice 3.1
 * 
 * Le compteur modulo est un compteur dont les etats accessibles
 * sont compris entre 0 et une valeur limite maximum (modulo-1).
 * 
 * @author F. Mallet et F. Boeri
 * @version 1
 */
public class CompteurModulo implements ACompteur {
    /** repr?sente l'?tat du compteur : 0<= etat < modulo*/
    private int etat;
    /** repr?sente le nombre d'?tats accessibles */
    private int modulo;
    
    /** constructeurs */
    public CompteurModulo(int modulo) {     
        this.etat = 0;
        this.modulo = modulo;
    }
    
    /** @return l'?tat courant du compteur */
    public int getEtat() { return etat; }
    
    /** saute ? l'?tat suivant */
    public void incrementer() {
        if (etat == modulo-1) {
            etat = 0;
        } else {
            etat += 1;
        }
    }
}