/**
 * Information Industrielle et Java
 * solution de l'exercice 3.1
 * 
 * Le compteur rapide incremente rapidement de plusieurs etats
 * un ACompteur donne
 * 
 * @author F. Mallet et F. Boeri
 * @version 1
 */
public class CompteurRapide {
    private ACompteur compteur;
    private int increment;
    
    /**
     * @param compteur, le compteur que l'on souhaite incrementer rapidement
     * @param increment, le nombre d'?tat ? sauter ? chaque appel d'incrementer
     */
    public CompteurRapide(ACompteur compteur, int increment) {
        this.compteur = compteur;
        this.increment = increment;
    }

    /**
     * incrementer rapidement le compteur sous-jacent
     */
    public void incrementer() {
        for (int i = 0; i<increment; i++) {
            compteur.incrementer();
        }
    }
    
    /**
     * @return etat courant du compteur sous-jacent
     */
    public int getEtat() {
        return compteur.getEtat();
    }
}
