/**
 * Informatique Industrielle et Java
 * Solution de l'exercice 3.4 chapitre3
 * 
 * Le compteur modulo est un compteur dont les etats accessibles
 * sont compris entre 0 et une valeur limite maximum (modulo-1).
 * 
 * @author F. Mallet 
 * @version 1
 */
public class CompteurModulo extends Compteur {
   /** l'attribut etat est h?rit? */
   
	/** repr?sente le nombre d'?tats accessibles */
	private int modulo;
	
	/** constructeurs */
	public CompteurModulo(int modulo) { 	
		super (); // invoque le constructeur par d?faut de Compteur
		this.modulo = modulo;
	}

	/** constructeurs 
	  * @param etat : ?tat initial, 0 <= etat < modulo
	  */
	public CompteurModulo(int etat, int modulo) { 	
		super (); // invoque le constructeur par d?faut de Compteur
		super.etat = etat;
		this.modulo = modulo;
	}

	// la m?thode getEtat est h?rit?e */	
	
	// La m?thode incrementer est h?rit?e puis red?finie */
	/** saute ? l'?tat suivant */
	public void incrementer() {
		if (etat == modulo-1) {
			etat = 0;
		} else {
			super.incrementer();
		}
	}
}